<?php
/**
 * Dairy Farming functions and definitions
 *
 * @package Dairy Farming
 */

if ( ! defined( 'DAIRY_FARMING_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'DAIRY_FARMING_VERSION', '1.0.0' );
}

function dairy_farming_setup() {

	load_theme_textdomain( 'dairy-farming', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'dairy-farming' ),
			'social-menu' => esc_html__('Social Menu', 'dairy-farming'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'dairy_farming_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'dairy_farming_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function dairy_farming_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'dairy_farming_content_width', 640 );
}
add_action( 'after_setup_theme', 'dairy_farming_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function dairy_farming_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'dairy-farming' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'dairy-farming' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'dairy-farming' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'dairy-farming' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'dairy-farming' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'dairy-farming' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'dairy-farming' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'dairy-farming' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'dairy_farming_widgets_init' );


function dairy_farming_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */
function dairy_farming_scripts() {

	// Load fonts locally
	require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

	$dairy_farming_font_families = array(
		'ZCOOL XiaoWei',
		'Oxygen:wght@300;400;700',
	);
	
	$dairy_farming_fonts_url = add_query_arg( array(
		'family' => implode( '&family=', $dairy_farming_font_families ),
		'display' => 'swap',
	), 'https://fonts.googleapis.com/css2' );

	wp_enqueue_style('dairy-farming-google-fonts', wptt_get_webfont_url(esc_url_raw($dairy_farming_fonts_url)), array(), '1.0.0');
	
	// Font Awesome CSS
	wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

	wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array());
	
	wp_enqueue_style( 'dairy-farming-style', get_stylesheet_uri(), array(), DAIRY_FARMING_VERSION );

	require get_parent_theme_file_path( '/custom-style.php' );
	wp_add_inline_style( 'dairy-farming-style',$dairy_farming_custom_css );

	wp_style_add_data('dairy-farming-style', 'rtl', 'replace');

	wp_enqueue_script( 'dairy-farming-navigation', get_template_directory_uri() . '/js/navigation.js', array(), DAIRY_FARMING_VERSION, true );

	wp_enqueue_script( 'owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array(), DAIRY_FARMING_VERSION, true );

	wp_enqueue_script( 'dairy-farming-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), DAIRY_FARMING_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'dairy_farming_scripts' );

if (!function_exists('dairy_farming_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function dairy_farming_related_post($post_id){        
        $dairy_farming_categories = get_the_category($post_id);
        if ($dairy_farming_categories) {
            $dairy_farming_category_ids = array();
            $dairy_farming_category = get_category($dairy_farming_category_ids);
            $dairy_farming_categories = get_the_category($post_id);
            foreach ($dairy_farming_categories as $dairy_farming_category) {
                $dairy_farming_category_ids[] = $dairy_farming_category->term_id;
            }
            $dairy_farming_count = $dairy_farming_category->category_count;
            if ($dairy_farming_count > 1) { ?>

         	<?php
		$dairy_farming_related_post_wrap = absint(get_theme_mod('dairy_farming_enable_related_post', 1));
		if($dairy_farming_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('dairy_farming_related_post_text', __('Related Post', 'dairy-farming'))); ?></h2>
                    <?php
                    $dairy_farming_cat_post_args = array(
                        'category__in' => $dairy_farming_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'dairy_farming_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $dairy_farming_featured_query = new WP_Query($dairy_farming_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($dairy_farming_featured_query->have_posts()) :

                        while ($dairy_farming_featured_query->have_posts()) : $dairy_farming_featured_query->the_post();
                            ?>

							<div class="card-item rel-card-item">
								<div class="card-content">
									<?php if ( has_post_thumbnail() ) { ?>
										<div class="card-media">
											<?php dairy_farming_post_thumbnail(); ?>
										</div>
									<?php } else {
										// Fallback default image
										$dairy_farming_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/image/slider2.png';
										echo '<img class="default-post-img" src="' . esc_url( $dairy_farming_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
									} ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
										<?php
										dairy_farming_posted_on();
										dairy_farming_posted_by();
										?>
									</div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('dairy_farming_related_posts', 'dairy_farming_related_post', 10, 1);

function dairy_farming_sanitize_choices( $dairy_farming_input, $dairy_farming_setting ) {
    global $wp_customize; 
    $control = $wp_customize->get_control( $dairy_farming_setting->id ); 
    if ( array_key_exists( $dairy_farming_input, $control->choices ) ) {
        return $dairy_farming_input;
    } else {
        return $dairy_farming_setting->default;
    }
}

//Excerpt 
function dairy_farming_excerpt_function($dairy_farming_excerpt_count = 35) {
    $dairy_farming_excerpt = get_the_excerpt();
    $dairy_farming_text_excerpt = wp_strip_all_tags($dairy_farming_excerpt);
    $dairy_farming_excerpt_limit = (int) get_theme_mod('dairy_farming_excerpt_limit', $dairy_farming_excerpt_count);
    $dairy_farming_words = preg_split('/\s+/', $dairy_farming_text_excerpt); 
    $dairy_farming_trimmed_words = array_slice($dairy_farming_words, 0, $dairy_farming_excerpt_limit);
    $dairy_farming_theme_excerpt = implode(' ', $dairy_farming_trimmed_words);

    return $dairy_farming_theme_excerpt;
}

// Add admin notice
function dairy_farming_admin_notice() { 
    global $pagenow;
    $dairy_farming_theme_args      = wp_get_theme();
    $dairy_farming_meta            = get_option( 'dairy_farming_admin_notice' );
    $name            = $dairy_farming_theme_args->__get( 'Name' );
    $dairy_farming_current_screen  = get_current_screen();

    if( !$dairy_farming_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $dairy_farming_current_screen->base !== 'appearance_page_dairy_farming_guide' && 
            $dairy_farming_current_screen->base !== 'toplevel_page_dairyfarming-demoimport' ) { ?>

            <div class="notice notice-success dairy-farming-welcome-notice">
                <p class="dairy-farming-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'dairy_farming_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'dairy-farming' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="dairy-farming-welcome-notice-wrap">
                    <h2 class="dairy-farming-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $dairy_farming_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'dairy-farming' ), $dairy_farming_theme_name ) );
                        ?>
                    </h2>
                    <p class="dairy-farming-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'dairy-farming' ); ?>
                    </p>

                    <div class="dairy-farming-welcome-info">
                        <div class="dairy-farming-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'dairy-farming' ); ?>">
                        </div>

                        <div class="dairy-farming-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'dairy-farming' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'dairy-farming' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=dairyfarming-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'dairy-farming' ); ?></a></p>
                        </div>

                        <div class="dairy-farming-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'dairy-farming' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'dairy-farming' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=dairy-farming-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'dairy-farming' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }
	}
}

add_action( 'admin_notices', 'dairy_farming_admin_notice' );

if( ! function_exists( 'dairy_farming_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function dairy_farming_update_admin_notice(){
    if ( isset( $_GET['dairy_farming_admin_notice'] ) && $_GET['dairy_farming_admin_notice'] = '1' ) {
        update_option( 'dairy_farming_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'dairy_farming_update_admin_notice' );


add_action('after_switch_theme', 'dairy_farming_setup_options');
function dairy_farming_setup_options () {
    update_option('dairy_farming_admin_notice', FALSE );
}


/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$checked`
 * as a boolean value, either TRUE or FALSE.
 */
function dairy_farming_sanitize_checkbox($checked)
{
    // Boolean check.
    return ((isset($checked) && true == $checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function dairy_farming_enqueue_function() {

	/**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/dairy_farming_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/dairy_farming_config_file.php';

	define('DAIRY_FARMING_FREE_SUPPORT',__('https://wordpress.org/support/theme/dairy-farming/','dairy-farming'));
	define('DAIRY_FARMING_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','dairy-farming'));
	define('DAIRY_FARMING_REVIEW',__('https://wordpress.org/support/theme/dairy-farming/reviews/#new-post','dairy-farming'));
	define('DAIRY_FARMING_BUY_NOW',__('https://www.revolutionwp.com/products/dairy-wordpress-theme','dairy-farming'));
	define('DAIRY_FARMING_LIVE_DEMO',__('https://demo.revolutionwp.com/dairy-farming-pro/','dairy-farming'));
	define('DAIRY_FARMING_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/dairy-farming-pro/','dairy-farming'));
	define('DAIRY_FARMING_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/dairy-farming-free','dairy-farming'));
	
}
add_action( 'after_setup_theme', 'dairy_farming_enqueue_function' );

function dairy_farming_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'dairy_farming_remove_customize_register', 11 );

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'dairy_farming_loop_columns');

if (!function_exists('dairy_farming_loop_columns')) {

	function dairy_farming_loop_columns() {

		$dairy_farming_columns = get_theme_mod( 'dairy_farming_per_columns', 3 );

		return $dairy_farming_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'dairy_farming_per_page', 20 );

function dairy_farming_per_page( $dairy_farming_cols ) {

  	$dairy_farming_cols = get_theme_mod( 'dairy_farming_product_per_page', 9 );

	return $dairy_farming_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'dairy_farming_products_args' );

function dairy_farming_products_args( $args ) {

    $args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function dairy_farming_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --dairy_farming_logo_width: <?php echo absint(get_theme_mod('dairy_farming_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('dairy_farming_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'dairy_farming_custom_css' );

function get_changelog_from_readme() {
	$file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

	if (file_exists($file_path)) {
		$content = file_get_contents($file_path);

		// Extract changelog section
		$changelog_start = strpos($content, "== Changelog ==");
		$changelog = substr($content, $changelog_start);

		// Split changelog into versions
		preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $changelog, $matches, PREG_SET_ORDER);
		
		return $matches;
	}
	return [];
}